# -*- encoding: utf-8 -*-
#################################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 Julius Network Solutions SARL <contact@julius.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#################################################################################

from osv import fields, osv

class purchase_order(osv.osv):
    _inherit = "purchase.order"

    """ Function to update all lines with the fiscal position chosen after the line creation 
    It's only writing the new taxes and new accounts in every line If it's in draft state """
    def update_fiscal_position(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        line_obj = self.pool.get('purchase.order.line')
        order_ids = self.browse(cr, uid, ids, context)
        for order in order_ids:
            if order.state != 'draft':
                raise osv.except_osv(_('Warning !'), _('You cannot change VAT if your purchase order is not in draft state.'))
            if not order.fiscal_position:
                continue
            for line in order.order_line:
                if line.product_id:
                    res = line_obj.product_id_change(cr, uid, [line.id], (order.pricelist_id and order.pricelist_id.id or False), (line.product_id and line.product_id.id or False), qty=(line.product_qty or 0),
                uom=(line.product_uom and line.product_uom.id or False), name=(line.name or ''), partner_id=order.partner_id.id,
                date_order=(order.date_order or False), date_planned=(line.date_planned or False), fiscal_position=order.fiscal_position.id, price_unit=(line.price_unit or 0), notes=(line.notes or False))
                    tax_ids = res['value']['taxes_id']
                    line_obj.write(cr, uid, [line.id], {'taxes_id': [(6, 0, tax_ids)]})
        return True

purchase_order()
